module Rinda

  class Service

    include DRb::DRbUndumped

    class << self
      attr_accessor :description
    end

    def self.start (addresses, *args)
      DRb.start_service
      Rinda::RingProvider.new(self.name.to_sym, self.new(*args), description, Rinda::SimpleRenewer.new(5)).provide
      DRb.thread.join
    end

    def self.open (addresses, name)
      DRb.start_service
      Rinda::RingFinger.new(addresses).each.first.read([:name, name, nil, nil])[2]
    end

  end

end
